<!DOCTYPE html>
<html>

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Bino Short URL</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bulma@0.8.0/css/bulma.min.css">
    <script defer src="https://use.fontawesome.com/releases/v5.3.1/js/all.js"></script>
    <style>
        form {
            margin-bottom: 2rem;
        }

        .buttons {
            padding: 1rem 0 2rem;
        }
    </style>
</head>

<body>
    <section class="section">
        <div class="container">
            <form action="/s" method="get">
                <div class="card">
                    <header class="card-header">
                        <p class="card-header-title">URL Shortener</p>
                    </header>
                    <div class="card-content">
                        <div class="content">
                            <div class="field is-horizontal">
                                <div class="field-body">
                                    <div class="field">
                                        <div class="control is-expanded has-icons-left">
                                            <input class="input" type="text" placeholder="paste/ type URL" name="url" tabindex="1">
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="card-footer buttons is-centered">
                        <button class="button is-primary" type="submit" name="submit" tabindex="9">Shorten</button>
                        <button class="button is-info" name="search" tabindex="2">Search</button>
                    </div>
                </div>
            </form>
            <div class="card is-hidden search-result">
                <div class="card-content">
                    <div class="content">
                        <progress class="progress is-large is-primary" max="100">50%</progress>
                    </div>
                </div>
            </div>
        </div>
    </section>
</body>
<script>
const copyToClipboard = () => {
    let input = document.createElement('input');
    let copyButton = document.querySelector("button[name=copy]");
    input.setAttribute('value', document.querySelector("#target").href);
    document.body.appendChild(input);
    input.select();
    let result = document.execCommand('copy');
    document.body.removeChild(input);

    copyButton.textContent = "copied"
    copyButton.classList.remove('is-primary');
    copyButton.classList.add('is-success');
    setTimeout(() => {
        copyButton.textContent = "copy"
        copyButton.classList.remove('is-success');
        copyButton.classList.add('is-primary');
    }, 2000)
    return result;
}

(function() {
    "use strict";

    if (!window.location.origin) {
        window.location.origin = window.location.protocol + "//" + window.location.hostname
        + (window.location.port ? ':' + window.location.port: '');
    }

    String.prototype.paramify = String.prototype.paramify || function () {
        let str = this.toString();
        if (arguments.length) {
            let t = typeof arguments[0];
            let key;
            let args = ("string" === t || "number" === t) ?
                Array.prototype.slice.call(arguments)
                : arguments[0];

            for (key in args) {
                str = str.replace(new RegExp("\\{" + key + "\\}", "gi"), args[key]);
            }
        }
        return str;
    };

    let formatData = data => {
        let template = `<i>{0}</i> <strong>mapped to</strong> <a href="{1}" target="_blank" rel="noopener noreferrer" id="target">{1}</a>
        <button class="button is-pulled-right is-primary" name="copy" onclick="copyToClipboard()">copy</button>`
        let content = JSON.parse(data);
        return template.paramify(content.url, window.location.origin + '/g/' + content.alias);
    }

    let processForm = type => {
        document.querySelector('.search-result').classList.remove('is-hidden');
        let xhr = new XMLHttpRequest();
        let searchResult = document.querySelector('.search-result .content')
        let endpoint = type == 'search' ? 'q' : 's';

        if(!xhr) {
            console.log("xhr error");
            searchResult.innerHTML = "Error processing request";
            return false;
        }
        xhr.onreadystatechange = () => {
            if (xhr.readyState === XMLHttpRequest.DONE) {
                if (xhr.status == 200 && xhr.responseText.length > 2) {
                    searchResult.innerHTML = formatData(xhr.responseText);
                } else {
                    searchResult.innerHTML = "Not found";
                }
            }
        }
        xhr.open('GET', '/'+ endpoint + '?url=' + document.querySelector('input[name=url]').value)
        xhr.send()
    }

    document.querySelector('button[name=submit]').addEventListener('click', event => {
        event.preventDefault();
        processForm('add');
    })
    document.querySelector('button[name=search]').addEventListener('click', event => {
        event.preventDefault();
        processForm('search');
    })
})();
</script>
</html> 